import type { Localization } from '../locale/types';
import { type PropType } from 'vue';
import { type Field, type Period } from '../types';
import { type UseCronSegmentReturn } from './cron-segment';
export type CronFormat = 'crontab' | 'quartz';
export interface CronOptions {
    initialValue?: string;
    initialPeriod?: string;
    locale?: string;
    fields?: Field[];
    periods?: Period[];
    customLocale?: Localization;
    format?: CronFormat;
}
export interface CronContext {
    segmentMap: Map<string, UseCronSegmentReturn>;
}
export declare function useCron(options: CronOptions): {
    cron: import("vue").Ref<string>;
    error: import("vue").Ref<string>;
    segments: {
        id: any;
        items: any;
        cron: import("vue").Ref<string>;
        selected: import("vue").Ref<number[]>;
        error: import("vue").Ref<string>;
        select: (evt: number[]) => void;
        text: import("vue").Ref<string>;
        prefix: import("vue").Ref<string>;
        suffix: import("vue").Ref<string>;
    }[];
    selected: import("vue").ComputedRef<{
        id: any;
        items: any;
        cron: import("vue").Ref<string>;
        selected: import("vue").Ref<number[]>;
        error: import("vue").Ref<string>;
        select: (evt: number[]) => void;
        text: import("vue").Ref<string>;
        prefix: import("vue").Ref<string>;
        suffix: import("vue").Ref<string>;
    }[]>;
    period: {
        select: (periodId: string) => void;
        selected: import("vue").Ref<{
            text: any;
            id: string;
            value: string[];
        }>;
        items: {
            text: any;
            id: string;
            value: string[];
        }[];
        prefix: import("vue").Ref<string>;
        suffix: import("vue").Ref<string>;
    };
};
export declare const cronProps: {
    modelValue: {
        type: StringConstructor;
    };
    initialPeriod: {
        type: StringConstructor;
    };
    format: {
        type: PropType<CronFormat>;
    };
    locale: {
        type: StringConstructor;
    };
    fields: {
        type: PropType<Field[]>;
    };
    periods: {
        type: PropType<Period[]>;
    };
    customLocale: {
        type: PropType<Localization>;
    };
};
export declare const CronCore: import("vue").DefineComponent<{
    modelValue: {
        type: StringConstructor;
    };
    initialPeriod: {
        type: StringConstructor;
    };
    format: {
        type: PropType<CronFormat>;
    };
    locale: {
        type: StringConstructor;
    };
    fields: {
        type: PropType<Field[]>;
    };
    periods: {
        type: PropType<Period[]>;
    };
    customLocale: {
        type: PropType<Localization>;
    };
}, () => import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
    [key: string]: any;
}>[] | undefined, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, ("update:model-value" | "error")[], "update:model-value" | "error", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    modelValue: {
        type: StringConstructor;
    };
    initialPeriod: {
        type: StringConstructor;
    };
    format: {
        type: PropType<CronFormat>;
    };
    locale: {
        type: StringConstructor;
    };
    fields: {
        type: PropType<Field[]>;
    };
    periods: {
        type: PropType<Period[]>;
    };
    customLocale: {
        type: PropType<Localization>;
    };
}>> & {
    "onUpdate:model-value"?: ((...args: any[]) => any) | undefined;
    onError?: ((...args: any[]) => any) | undefined;
}, {}, {}>;
